This repository has been archived on 2021-07-22. You can view files and clone it, but cannot push or open issues or pull requests.
abra/abra

1070 lines
35 KiB
Plaintext
Raw Normal View History

2020-10-25 20:41:17 +00:00
#!/usr/bin/env bash
GIT_URL="https://git.autonomic.zone/coop-cloud/"
ABRA_DIR="${ABRA_DIR:-$HOME/.abra}"
2020-10-27 19:38:20 +00:00
#######################################
# Global help
#######################################
2020-10-25 20:41:17 +00:00
2020-10-26 09:05:03 +00:00
DOC="
The cooperative cloud utility belt 🎩🐇
2020-10-25 20:41:17 +00:00
Usage:
abra [options] app new [--server=<server>] [--domain=<domain>] [--pass] [--auto] <app>
abra [options] app (list|ls) [--status] [--server=<server>]
2020-10-27 19:38:20 +00:00
abra [options] app <domain> deploy
2020-10-27 23:40:35 +00:00
abra [options] app <domain> undeploy
2020-10-28 08:25:56 +00:00
abra [options] app <domain> config
2020-10-27 23:52:27 +00:00
abra [options] app <domain> (delete|rm) [--force]
2020-10-27 19:38:20 +00:00
abra [options] app <domain> logs [<service>]
abra [options] app <domain> multilogs
abra [options] app <domain> cp <src> <dst>
abra [options] app <domain> check
abra [options] app <domain> ps
2020-12-26 15:22:56 +00:00
abra [options] app <domain> run [--no-tty] [--user=<user>] <service> <args>...
2020-10-27 19:38:20 +00:00
abra [options] app <domain> run <service> <args>...
abra [options] app <domain> secret auto [--pass]
abra [options] app <domain> secret generate <secret> <version> [<cmd>] [--pass]
abra [options] app <domain> secret insert <secret> <version> <data> [--pass]
2020-11-01 19:55:47 +00:00
abra [options] app <domain> secret (delete|rm) (<secret>|--all) [--pass] [--force]
abra [options] app <domain> <command> [<args>...]
abra [options] server add <host> [<user>] [<port>]
2020-10-27 21:46:03 +00:00
abra [options] server (list|ls)
abra [options] server <host> rm
abra [options] server <host> use
abra [options] server <host> init
abra [options] server <host> apps [--status]
abra [options] upgrade
2020-10-25 20:41:17 +00:00
Options:
2020-10-26 08:46:14 +00:00
-e, --env=<path> Environment variables to load
-h, --help Show this message and exit
-s, --stack=<stack> Name of the target stack
2020-10-26 08:46:14 +00:00
-v, --version Show program version
See 'abra help <command>' to read about a specific subcommand.
2020-10-26 09:05:03 +00:00
"
2020-10-25 20:41:17 +00:00
# docopt parser below, refresh this parser with `docopt.sh abra`
2020-10-26 09:05:03 +00:00
# shellcheck disable=2016,1075,2154
2020-10-25 20:41:17 +00:00
docopt() { parse() { if ${DOCOPT_DOC_CHECK:-true}; then local doc_hash
if doc_hash=$(printf "%s" "$DOC" | (sha256sum 2>/dev/null || shasum -a 256)); then
if [[ ${doc_hash:0:5} != "$digest" ]]; then
stderr "The current usage doc (${doc_hash:0:5}) does not match \
what the parser was generated with (${digest})
Run \`docopt.sh\` to refresh the parser."; _return 70; fi; fi; fi
local root_idx=$1; shift; argv=("$@"); parsed_params=(); parsed_values=()
left=(); testdepth=0; local arg; while [[ ${#argv[@]} -gt 0 ]]; do
if [[ ${argv[0]} = "--" ]]; then for arg in "${argv[@]}"; do
parsed_params+=('a'); parsed_values+=("$arg"); done; break
elif [[ ${argv[0]} = --* ]]; then parse_long
elif [[ ${argv[0]} = -* && ${argv[0]} != "-" ]]; then parse_shorts
elif ${DOCOPT_OPTIONS_FIRST:-false}; then for arg in "${argv[@]}"; do
parsed_params+=('a'); parsed_values+=("$arg"); done; break; else
parsed_params+=('a'); parsed_values+=("${argv[0]}"); argv=("${argv[@]:1}"); fi
done; local idx; if ${DOCOPT_ADD_HELP:-true}; then
for idx in "${parsed_params[@]}"; do [[ $idx = 'a' ]] && continue
if [[ ${shorts[$idx]} = "-h" || ${longs[$idx]} = "--help" ]]; then
stdout "$trimmed_doc"; _return 0; fi; done; fi
if [[ ${DOCOPT_PROGRAM_VERSION:-false} != 'false' ]]; then
for idx in "${parsed_params[@]}"; do [[ $idx = 'a' ]] && continue
if [[ ${longs[$idx]} = "--version" ]]; then stdout "$DOCOPT_PROGRAM_VERSION"
_return 0; fi; done; fi; local i=0; while [[ $i -lt ${#parsed_params[@]} ]]; do
left+=("$i"); ((i++)) || true; done
if ! required "$root_idx" || [ ${#left[@]} -gt 0 ]; then error; fi; return 0; }
parse_shorts() { local token=${argv[0]}; local value; argv=("${argv[@]:1}")
[[ $token = -* && $token != --* ]] || _return 88; local remaining=${token#-}
while [[ -n $remaining ]]; do local short="-${remaining:0:1}"
remaining="${remaining:1}"; local i=0; local similar=(); local match=false
for o in "${shorts[@]}"; do if [[ $o = "$short" ]]; then similar+=("$short")
[[ $match = false ]] && match=$i; fi; ((i++)) || true; done
if [[ ${#similar[@]} -gt 1 ]]; then
error "${short} is specified ambiguously ${#similar[@]} times"
elif [[ ${#similar[@]} -lt 1 ]]; then match=${#shorts[@]}; value=true
shorts+=("$short"); longs+=(''); argcounts+=(0); else value=false
if [[ ${argcounts[$match]} -ne 0 ]]; then if [[ $remaining = '' ]]; then
if [[ ${#argv[@]} -eq 0 || ${argv[0]} = '--' ]]; then
error "${short} requires argument"; fi; value=${argv[0]}; argv=("${argv[@]:1}")
else value=$remaining; remaining=''; fi; fi; if [[ $value = false ]]; then
value=true; fi; fi; parsed_params+=("$match"); parsed_values+=("$value"); done
}; parse_long() { local token=${argv[0]}; local long=${token%%=*}
local value=${token#*=}; local argcount; argv=("${argv[@]:1}")
[[ $token = --* ]] || _return 88; if [[ $token = *=* ]]; then eq='='; else eq=''
value=false; fi; local i=0; local similar=(); local match=false
for o in "${longs[@]}"; do if [[ $o = "$long" ]]; then similar+=("$long")
[[ $match = false ]] && match=$i; fi; ((i++)) || true; done
if [[ $match = false ]]; then i=0; for o in "${longs[@]}"; do
if [[ $o = $long* ]]; then similar+=("$long"); [[ $match = false ]] && match=$i
fi; ((i++)) || true; done; fi; if [[ ${#similar[@]} -gt 1 ]]; then
error "${long} is not a unique prefix: ${similar[*]}?"
elif [[ ${#similar[@]} -lt 1 ]]; then
[[ $eq = '=' ]] && argcount=1 || argcount=0; match=${#shorts[@]}
[[ $argcount -eq 0 ]] && value=true; shorts+=(''); longs+=("$long")
argcounts+=("$argcount"); else if [[ ${argcounts[$match]} -eq 0 ]]; then
if [[ $value != false ]]; then
error "${longs[$match]} must not have an argument"; fi
elif [[ $value = false ]]; then
if [[ ${#argv[@]} -eq 0 || ${argv[0]} = '--' ]]; then
error "${long} requires argument"; fi; value=${argv[0]}; argv=("${argv[@]:1}")
fi; if [[ $value = false ]]; then value=true; fi; fi; parsed_params+=("$match")
parsed_values+=("$value"); }; required() { local initial_left=("${left[@]}")
local node_idx; ((testdepth++)) || true; for node_idx in "$@"; do
if ! "node_$node_idx"; then left=("${initial_left[@]}"); ((testdepth--)) || true
return 1; fi; done; if [[ $((--testdepth)) -eq 0 ]]; then
left=("${initial_left[@]}"); for node_idx in "$@"; do "node_$node_idx"; done; fi
2020-10-26 09:05:03 +00:00
return 0; }; either() { local initial_left=("${left[@]}"); local best_match_idx
local match_count; local node_idx; ((testdepth++)) || true
for node_idx in "$@"; do if "node_$node_idx"; then
if [[ -z $match_count || ${#left[@]} -lt $match_count ]]; then
best_match_idx=$node_idx; match_count=${#left[@]}; fi; fi
left=("${initial_left[@]}"); done; ((testdepth--)) || true
if [[ -n $best_match_idx ]]; then "node_$best_match_idx"; return 0; fi
left=("${initial_left[@]}"); return 1; }; optional() { local node_idx
for node_idx in "$@"; do "node_$node_idx"; done; return 0; }; oneormore() {
local i=0; local prev=${#left[@]}; while "node_$1"; do ((i++)) || true
[[ $prev -eq ${#left[@]} ]] && break; prev=${#left[@]}; done
if [[ $i -ge 1 ]]; then return 0; fi; return 1; }; _command() { local i
local name=${2:-$1}; for i in "${!left[@]}"; do local l=${left[$i]}
if [[ ${parsed_params[$l]} = 'a' ]]; then
if [[ ${parsed_values[$l]} != "$name" ]]; then return 1; fi
left=("${left[@]:0:$i}" "${left[@]:((i+1))}")
[[ $testdepth -gt 0 ]] && return 0; if [[ $3 = true ]]; then
eval "((var_$1++)) || true"; else eval "var_$1=true"; fi; return 0; fi; done
return 1; }; switch() { local i; for i in "${!left[@]}"; do local l=${left[$i]}
2020-10-26 08:46:14 +00:00
if [[ ${parsed_params[$l]} = "$2" ]]; then
left=("${left[@]:0:$i}" "${left[@]:((i+1))}")
[[ $testdepth -gt 0 ]] && return 0; if [[ $3 = true ]]; then
eval "((var_$1++))" || true; else eval "var_$1=true"; fi; return 0; fi; done
return 1; }; value() { local i; for i in "${!left[@]}"; do local l=${left[$i]}
if [[ ${parsed_params[$l]} = "$2" ]]; then
left=("${left[@]:0:$i}" "${left[@]:((i+1))}")
[[ $testdepth -gt 0 ]] && return 0; local value
value=$(printf -- "%q" "${parsed_values[$l]}"); if [[ $3 = true ]]; then
eval "var_$1+=($value)"; else eval "var_$1=$value"; fi; return 0; fi; done
return 1; }; stdout() { printf -- "cat <<'EOM'\n%s\nEOM\n" "$1"; }; stderr() {
2020-10-25 20:41:17 +00:00
printf -- "cat <<'EOM' >&2\n%s\nEOM\n" "$1"; }; error() {
[[ -n $1 ]] && stderr "$1"; stderr "$usage"; _return 1; }; _return() {
2020-12-26 15:22:56 +00:00
printf -- "exit %d\n" "$1"; exit "$1"; }; set -e; trimmed_doc=${DOC:1:1579}
usage=${DOC:40:1271}; digest=974cf
shorts=(-h -e -s -v '' '' '' '' '' '' '' '' '')
longs=(--help --env --stack --version --server --domain --pass --auto --status --force --no-tty --user --all)
argcounts=(0 1 1 0 1 1 0 0 0 0 0 1 0); node_0(){ switch __help 0; }; node_1(){
value __env 1; }; node_2(){ value __stack 2; }; node_3(){ switch __version 3; }
node_4(){ value __server 4; }; node_5(){ value __domain 5; }; node_6(){
switch __pass 6; }; node_7(){ switch __auto 7; }; node_8(){ switch __status 8; }
2020-12-26 15:22:56 +00:00
node_9(){ switch __force 9; }; node_10(){ switch __no_tty 10; }; node_11(){
value __user 11; }; node_12(){ switch __all 12; }; node_13(){ value _app_ a; }
node_14(){ value _domain_ a; }; node_15(){ value _service_ a; }; node_16(){
value _src_ a; }; node_17(){ value _dst_ a; }; node_18(){ value _args_ a true; }
node_19(){ value _secret_ a; }; node_20(){ value _version_ a; }; node_21(){
value _cmd_ a; }; node_22(){ value _data_ a; }; node_23(){ value _command_ a; }
2020-12-14 10:33:22 +00:00
node_24(){ value _host_ a; }; node_25(){ value _user_ a; }; node_26(){
value _port_ a; }; node_27(){ _command app; }; node_28(){ _command new; }
node_29(){ _command list; }; node_30(){ _command ls; }; node_31(){
_command deploy; }; node_32(){ _command undeploy; }; node_33(){ _command config
}; node_34(){ _command delete; }; node_35(){ _command rm; }; node_36(){
_command logs; }; node_37(){ _command multilogs; }; node_38(){ _command cp; }
node_39(){ _command check; }; node_40(){ _command ps; }; node_41(){ _command run
}; node_42(){ _command secret; }; node_43(){ _command auto; }; node_44(){
_command generate; }; node_45(){ _command insert; }; node_46(){ _command server
}; node_47(){ _command add; }; node_48(){ _command use; }; node_49(){
_command init; }; node_50(){ _command apps; }; node_51(){ _command upgrade; }
node_52(){ optional 0 1 2 3; }; node_53(){ optional 52; }; node_54(){ optional 4
}; node_55(){ optional 5; }; node_56(){ optional 6; }; node_57(){ optional 7; }
2020-12-26 15:22:56 +00:00
node_58(){ required 53 27 28 54 55 56 57 13; }; node_59(){ either 29 30; }
node_60(){ required 59; }; node_61(){ optional 8; }; node_62(){
2020-12-26 15:22:56 +00:00
required 53 27 60 61 54; }; node_63(){ required 53 27 14 31; }; node_64(){
required 53 27 14 32; }; node_65(){ required 53 27 14 33; }; node_66(){
either 34 35; }; node_67(){ required 66; }; node_68(){ optional 9; }; node_69(){
2020-12-26 15:22:56 +00:00
required 53 27 14 67 68; }; node_70(){ optional 15; }; node_71(){
required 53 27 14 36 70; }; node_72(){ required 53 27 14 37; }; node_73(){
required 53 27 14 38 16 17; }; node_74(){ required 53 27 14 39; }; node_75(){
required 53 27 14 40; }; node_76(){ optional 10; }; node_77(){ optional 11; }
node_78(){ oneormore 18; }; node_79(){ required 53 27 14 41 76 77 15 78; }
node_80(){ required 53 27 14 41 15 78; }; node_81(){ required 53 27 14 42 43 56
}; node_82(){ optional 21; }; node_83(){ required 53 27 14 42 44 19 20 82 56; }
node_84(){ required 53 27 14 42 45 19 20 22 56; }; node_85(){ either 19 12; }
node_86(){ required 85; }; node_87(){ required 53 27 14 42 67 86 56 68; }
node_88(){ optional 78; }; node_89(){ required 53 27 14 23 88; }; node_90(){
optional 25; }; node_91(){ optional 26; }; node_92(){ required 53 46 47 24 90 91
}; node_93(){ required 53 46 60; }; node_94(){ required 53 46 24 35; }
node_95(){ required 53 46 24 48; }; node_96(){ required 53 46 24 49; }
node_97(){ required 53 46 24 50 61; }; node_98(){ required 53 51; }; node_99(){
either 58 62 63 64 65 69 71 72 73 74 75 79 80 81 83 84 87 89 92 93 94 95 96 97 98
}; node_100(){ required 99; }; cat <<<' docopt_exit() {
[[ -n $1 ]] && printf "%s\n" "$1" >&2; printf "%s\n" "${DOC:40:1271}" >&2
exit 1; }'; unset var___help var___env var___stack var___version var___server \
var___domain var___pass var___auto var___status var___force var___no_tty \
var___user var___all var__app_ var__domain_ var__service_ var__src_ var__dst_ \
var__args_ var__secret_ var__version_ var__cmd_ var__data_ var__command_ \
2020-12-14 10:33:22 +00:00
var__host_ var__user_ var__port_ var_app var_new var_list var_ls var_deploy \
var_undeploy var_config var_delete var_rm var_logs var_multilogs var_cp \
var_check var_ps var_run var_secret var_auto var_generate var_insert \
2020-12-26 15:22:56 +00:00
var_server var_add var_use var_init var_apps var_upgrade; parse 100 "$@"
local prefix=${DOCOPT_PREFIX:-''}; unset "${prefix}__help" "${prefix}__env" \
2020-12-26 15:22:56 +00:00
"${prefix}__stack" "${prefix}__version" "${prefix}__server" \
"${prefix}__domain" "${prefix}__pass" "${prefix}__auto" "${prefix}__status" \
2020-12-26 15:22:56 +00:00
"${prefix}__force" "${prefix}__no_tty" "${prefix}__user" "${prefix}__all" \
"${prefix}_app_" "${prefix}_domain_" "${prefix}_service_" "${prefix}_src_" \
"${prefix}_dst_" "${prefix}_args_" "${prefix}_secret_" "${prefix}_version_" \
"${prefix}_cmd_" "${prefix}_data_" "${prefix}_command_" "${prefix}_host_" \
"${prefix}_user_" "${prefix}_port_" "${prefix}app" "${prefix}new" \
"${prefix}list" "${prefix}ls" "${prefix}deploy" "${prefix}undeploy" \
"${prefix}config" "${prefix}delete" "${prefix}rm" "${prefix}logs" \
"${prefix}multilogs" "${prefix}cp" "${prefix}check" "${prefix}ps" \
"${prefix}run" "${prefix}secret" "${prefix}auto" "${prefix}generate" \
"${prefix}insert" "${prefix}server" "${prefix}add" "${prefix}use" \
"${prefix}init" "${prefix}apps" "${prefix}upgrade"
eval "${prefix}"'__help=${var___help:-false}'
eval "${prefix}"'__env=${var___env:-}'
2020-12-14 10:33:22 +00:00
eval "${prefix}"'__stack=${var___stack:-}'
2020-12-26 15:22:56 +00:00
eval "${prefix}"'__version=${var___version:-false}'
eval "${prefix}"'__server=${var___server:-}'
eval "${prefix}"'__domain=${var___domain:-}'
eval "${prefix}"'__pass=${var___pass:-false}'
eval "${prefix}"'__auto=${var___auto:-false}'
eval "${prefix}"'__status=${var___status:-false}'
2020-10-27 23:52:27 +00:00
eval "${prefix}"'__force=${var___force:-false}'
2020-12-26 15:22:56 +00:00
eval "${prefix}"'__no_tty=${var___no_tty:-false}'
eval "${prefix}"'__user=${var___user:-}'
eval "${prefix}"'__all=${var___all:-false}'
eval "${prefix}"'_app_=${var__app_:-}'
eval "${prefix}"'_domain_=${var__domain_:-}'
2020-10-26 14:54:55 +00:00
eval "${prefix}"'_service_=${var__service_:-}'
eval "${prefix}"'_src_=${var__src_:-}'; eval "${prefix}"'_dst_=${var__dst_:-}'
2020-10-26 09:05:03 +00:00
if declare -p var__args_ >/dev/null 2>&1; then
eval "${prefix}"'_args_=("${var__args_[@]}")'; else eval "${prefix}"'_args_=()'
fi; eval "${prefix}"'_secret_=${var__secret_:-}'
eval "${prefix}"'_version_=${var__version_:-}'
eval "${prefix}"'_cmd_=${var__cmd_:-}'; eval "${prefix}"'_data_=${var__data_:-}'
2020-12-14 10:33:22 +00:00
eval "${prefix}"'_command_=${var__command_:-}'
2020-12-26 15:22:56 +00:00
eval "${prefix}"'_host_=${var__host_:-}'
eval "${prefix}"'_user_=${var__user_:-}'
eval "${prefix}"'_port_=${var__port_:-}'
2020-10-27 19:38:20 +00:00
eval "${prefix}"'app=${var_app:-false}'; eval "${prefix}"'new=${var_new:-false}'
eval "${prefix}"'list=${var_list:-false}'; eval "${prefix}"'ls=${var_ls:-false}'
eval "${prefix}"'deploy=${var_deploy:-false}'
2020-10-27 23:40:35 +00:00
eval "${prefix}"'undeploy=${var_undeploy:-false}'
2020-10-28 08:25:56 +00:00
eval "${prefix}"'config=${var_config:-false}'
2020-10-27 23:40:35 +00:00
eval "${prefix}"'delete=${var_delete:-false}'
eval "${prefix}"'rm=${var_rm:-false}'; eval "${prefix}"'logs=${var_logs:-false}'
eval "${prefix}"'multilogs=${var_multilogs:-false}'
eval "${prefix}"'cp=${var_cp:-false}'
eval "${prefix}"'check=${var_check:-false}'
eval "${prefix}"'ps=${var_ps:-false}'; eval "${prefix}"'run=${var_run:-false}'
eval "${prefix}"'secret=${var_secret:-false}'
2020-10-27 22:29:40 +00:00
eval "${prefix}"'auto=${var_auto:-false}'
eval "${prefix}"'generate=${var_generate:-false}'
eval "${prefix}"'insert=${var_insert:-false}'
eval "${prefix}"'server=${var_server:-false}'
2020-10-27 23:40:35 +00:00
eval "${prefix}"'add=${var_add:-false}'; eval "${prefix}"'use=${var_use:-false}'
2020-10-27 19:38:20 +00:00
eval "${prefix}"'init=${var_init:-false}'
eval "${prefix}"'apps=${var_apps:-false}'
eval "${prefix}"'upgrade=${var_upgrade:-false}'; local docopt_i=1
[[ $BASH_VERSION =~ ^4.3 ]] && docopt_i=2; for ((;docopt_i>0;docopt_i--)); do
2020-12-26 15:22:56 +00:00
declare -p "${prefix}__help" "${prefix}__env" "${prefix}__stack" \
"${prefix}__version" "${prefix}__server" "${prefix}__domain" "${prefix}__pass" \
"${prefix}__auto" "${prefix}__status" "${prefix}__force" "${prefix}__no_tty" \
"${prefix}__user" "${prefix}__all" "${prefix}_app_" "${prefix}_domain_" \
"${prefix}_service_" "${prefix}_src_" "${prefix}_dst_" "${prefix}_args_" \
"${prefix}_secret_" "${prefix}_version_" "${prefix}_cmd_" "${prefix}_data_" \
"${prefix}_command_" "${prefix}_host_" "${prefix}_user_" "${prefix}_port_" \
2020-12-14 10:33:22 +00:00
"${prefix}app" "${prefix}new" "${prefix}list" "${prefix}ls" "${prefix}deploy" \
"${prefix}undeploy" "${prefix}config" "${prefix}delete" "${prefix}rm" \
"${prefix}logs" "${prefix}multilogs" "${prefix}cp" "${prefix}check" \
"${prefix}ps" "${prefix}run" "${prefix}secret" "${prefix}auto" \
"${prefix}generate" "${prefix}insert" "${prefix}server" "${prefix}add" \
"${prefix}use" "${prefix}init" "${prefix}apps" "${prefix}upgrade"; done; }
2020-10-25 20:41:17 +00:00
# docopt parser above, complete command for generating this parser is `docopt.sh abra`
2020-09-13 22:16:46 +00:00
2020-09-13 21:33:55 +00:00
PROGRAM_NAME=$(basename "$0")
2020-09-13 22:16:46 +00:00
2020-10-27 19:38:20 +00:00
#######################################
# Helpers
#######################################
###### Utility functions
error() {
echo "$(tput setaf 1)ERROR: $*$(tput sgr0)"
exit 1
2020-09-23 09:53:34 +00:00
}
warning() {
echo "$(tput setaf 3)WARNING: $*$(tput sgr0)"
}
success() {
echo "$(tput setaf 2)$*$(tput sgr0)"
}
###### Default settings
if [ -z "$COMPOSE_FILE" ]; then
COMPOSE_FILE="compose.yml"
fi
###### Safety checks
2020-09-24 22:36:23 +00:00
require_multitail() {
if ! type multitail > /dev/null 2>&1; then
error "multitail program is not installed"
fi
2020-09-24 22:36:23 +00:00
}
require_abra_dir() {
mkdir -p "$ABRA_DIR"
}
2020-09-23 09:53:34 +00:00
require_stack() {
if [ -z "$STACK_NAME" ]; then
2020-10-26 17:36:28 +00:00
error "no stack_name, export \$STACK_NAME=my_cool_app"
fi
2020-09-23 09:53:34 +00:00
}
2020-11-01 16:04:58 +00:00
require_app_clone() {
APP="$1"
APP_DIR="$ABRA_DIR/apps/$APP"
if [ ! -d "$APP_DIR" ]; then
warning "'$APP' not found, fetching via git.."
if ! git clone "$GIT_URL/$APP.git" "$ABRA_DIR/apps/$APP"; then
error "Could not retrieve '$APP', this app doesn't exist?"
fi
fi
}
# FIXME 3wc: update or remove
if [ -z "$ABRA_ENV" ] && [ -f .envrc ] && type direnv > /dev/null 2>&1 && ! direnv status | grep -q 'Found RC allowed true'; then
error "direnv is blocked, run direnv allow"
2020-09-07 21:29:29 +00:00
fi
2020-09-08 06:49:27 +00:00
2020-10-26 11:46:54 +00:00
###### Run-time loading
2020-10-26 11:46:54 +00:00
load_custom_commands() {
if [ -f abra-commands.sh ]; then
# shellcheck disable=SC1091
source abra-commands.sh
fi
2020-12-17 11:38:30 +00:00
if [ -n "$abra__domain_" ]; then
load_instance
load_instance_env
require_app_clone "$APP"
fi
2020-10-27 21:46:03 +00:00
if [ -f "$APP_DIR/abra-commands.sh" ]; then
2020-10-30 16:30:53 +00:00
# shellcheck disable=SC1090,SC1091
2020-10-27 21:46:03 +00:00
source "$APP_DIR/abra-commands.sh"
fi
2020-10-26 11:46:54 +00:00
}
2020-10-27 21:46:03 +00:00
###### FIXME 3wc: name this section
get_servers() {
shopt -s nullglob dotglob
# shellcheck disable=SC2206
SERVERS=($ABRA_DIR/servers/*)
2020-10-27 21:46:03 +00:00
shopt -u nullglob dotglob
}
2020-10-27 22:29:40 +00:00
get_app_secrets() {
2020-11-05 14:56:31 +00:00
get_app_passwords
get_app_keys
}
get_app_passwords() {
# FIXME 3wc: requires bash 4, use for loop instead
mapfile -t PASSWORDS < <(grep "SECRET.*PASSWORD.*VERSION.*" "$ENV_FILE" | cut -d ' ' -f2-)
}
get_app_keys() {
2020-10-27 23:40:35 +00:00
# FIXME 3wc: requires bash 4, use for loop instead
2020-11-05 14:56:31 +00:00
mapfile -t KEYS < <(grep "SECRET.*KEY.*VERSION.*" "$ENV_FILE" | cut -d' ' -f2-)
2020-10-27 22:29:40 +00:00
}
load_instance() {
DOMAIN="$abra__domain_"
2020-10-27 23:40:35 +00:00
# FIXME 3wc: requires bash 4, use for loop instead
mapfile -t ENV_FILES < <(find -L "$ABRA_DIR" -name "$DOMAIN.env")
2020-10-27 23:40:35 +00:00
case "${#ENV_FILES[@]}" in
1 ) ;;
0 ) error "Can't find app '$DOMAIN'"; return;;
* ) error "Found $DOMAIN in multiple servers: ${ENV_FILES[*]}"; return;;
esac
ENV_FILE="${ENV_FILES[0]}"
if [ ! -f "$ENV_FILE" ]; then
error "Can't open ENV_FILE '$ENV_FILE'"
fi
IFS='/' read -r -a PARTS <<< "$ENV_FILE"
SERVER="${PARTS[-2]}"
export STACK_NAME="${DOMAIN//./_}"
}
load_instance_env() {
# shellcheck disable=SC1090
source "$ENV_FILE"
if [ -z "$APP" ]; then
error "APP not set, maybe $ENV_FILE is using an old format?"
fi
APP_DIR="$ABRA_DIR/apps/$APP"
export DOCKER_CONTEXT="$SERVER"
export DOMAIN
}
2020-10-26 11:46:54 +00:00
load_context() {
# Load current context from env or Docker
if [ -z "$DOCKER_CONTEXT" ]; then
warning "\$DOCKER_CONTEXT not set, (slowly) looking it up"
# shellcheck disable=SC2063
DOCKER_CONTEXT=$(docker context ls | grep '*' | cut -d' ' -f1)
# make sure grep doesn't parse this, we want a literal '*'
fi
2020-10-26 11:46:54 +00:00
}
2020-10-30 18:57:13 +00:00
prompt_confirm() {
read -rp "Continue? (y/[n])? " choice
case "$choice" in
y|Y ) return ;;
* ) exit;;
esac
}
2020-11-05 14:56:31 +00:00
parse_secret() {
SECRET="$1"
if [[ "$SECRET" == *"length"* ]]; then
2020-11-05 15:00:50 +00:00
# shellcheck disable=SC2001
abra__length_="$(echo "$SECRET" | sed -e 's/.*[^0-9]\([0-9]\+\)[^0-9]*$/\1/')"
2020-11-05 14:56:31 +00:00
else
abra__length_=32
fi
abra__secret_="${SECRET%_VERSION=*}" # strip _VERSION=v1
abra__secret_="${abra__secret_#SECRET_}" # strip SECRET_
abra__secret_="${abra__secret_,,}" # lowercase
2020-11-05 15:00:50 +00:00
abra__version_="$(echo "$SECRET" | sed -n 's/.*\(v[0-9]\).*/\1/p')"
2020-11-05 14:56:31 +00:00
echo "Generating $abra__secret_, version: $abra__version_, length: $abra__length_"
sub_app_secret_generate
}
2020-10-27 19:38:20 +00:00
#######################################
# abra app ..
#######################################
2020-10-27 19:38:20 +00:00
###### .. app (list|ls)
sub_app_ls (){
sub_app_list
}
2020-10-27 19:38:20 +00:00
sub_app_list (){
SERVER="$abra___server"
if [ -z "$SERVER" ]; then
SERVER='*'
fi
2020-10-27 19:38:20 +00:00
shopt -s nullglob dotglob
# shellcheck disable=SC2206
ENV_FILES=($ABRA_DIR/servers/$SERVER/*.env)
2020-10-27 19:38:20 +00:00
shopt -u nullglob dotglob
2020-11-17 22:40:26 +00:00
STATUS="$( [[ $abra___status == "true" ]] && echo "Y" )"
if [ -n "$STATUS" ]; then
if [ -z "$SERVER" ]; then
get_servers
else
SERVERS=( "$SERVER" )
fi
local -a DEPLOYED_APPS # array
warning "Loading status from ${#SERVERS[@]} server(s), patience advised.."
for SERVER in "${SERVERS[@]}"; do
SERVER="${SERVER##*/}" # basename
mapfile -t SERVER_APPS < <(DOCKER_CONTEXT="$SERVER" docker stack ls --format '{{ .Name }}')
# add $SERVER~ to the start of each DEPLOYED_APPS
2020-11-08 15:34:21 +00:00
DEPLOYED_APPS+=("${SERVER_APPS[@]/#/$SERVER~}")
done
fi
2020-10-27 19:38:20 +00:00
printf "%s lovely apps:\n\n" "${#ENV_FILES[@]}"
2020-10-27 19:38:20 +00:00
for i in "${!ENV_FILES[@]}"; do
# Output header inside the loop, so it's included in the pipe to `column`
2020-10-27 19:38:20 +00:00
if [ "$i" == 0 ]; then
2020-11-17 23:06:07 +00:00
printf " DOMAIN\tAPP\tSERVER%s%s\n" "${STATUS:+ }" "${STATUS:+STATUS}"
printf " --\t--\t--%s\n" "${STATUS:+ --}"
2020-10-27 19:38:20 +00:00
fi
2020-09-08 06:49:27 +00:00
local ENV_FILE="${ENV_FILES[$i]}" APP_STACK_NAME
2020-10-27 19:38:20 +00:00
IFS='/' read -r -a PARTS <<< "$ENV_FILE"
2020-09-07 21:29:29 +00:00
2020-10-27 19:38:20 +00:00
FILE="${PARTS[-1]}"
SERVER="${PARTS[-2]}"
DOMAIN="${FILE%.env}"
# shellcheck disable=SC1090
APP="$(source "$ENV_FILE" && echo "$APP")"
# shellcheck disable=SC1090
APP_STACK_NAME="$(source "$ENV_FILE" && echo "$STACK_NAME")"
2020-12-26 10:09:39 +00:00
if [ -z "$APP_STACK_NAME" ]; then
APP_STACK_NAME="${DOMAIN//./_}"
fi
if [ -n "$STATUS" ]; then
2020-11-17 22:40:26 +00:00
APP_STATUS=$( printf '%s\n' "${DEPLOYED_APPS[@]}" | grep -qP "^${SERVER}~${APP_STACK_NAME}$" && echo "deployed" || echo "inactive")
fi
2020-11-17 22:40:26 +00:00
printf " %s\t%s\t%s%s\n" "$DOMAIN" "$APP" "$SERVER" "${STATUS:+ }${APP_STATUS}"
2020-10-27 19:38:20 +00:00
done | column -s' ' -t
2020-10-27 21:46:03 +00:00
# Align table `-t` based on tab characters -s`^V<Tab>`
2020-09-07 21:29:29 +00:00
}
2020-10-27 19:38:20 +00:00
###### .. app new [--domain=<domain> --server=<server>]
sub_app_new (){
require_abra_dir
2020-10-27 21:46:03 +00:00
get_servers
APP=$abra__app_
SERVER=$abra___server
DOMAIN=$abra___domain
2020-11-01 16:04:58 +00:00
require_app_clone "$APP"
if [ -z "$SERVER" ]; then
echo "Where would you like to put $APP?"
2020-11-01 16:05:13 +00:00
select SERVER_ITEM in "${SERVERS[@]##*/}"; do
2020-10-30 14:25:48 +00:00
if [ 1 -le "$REPLY" ] && [ "$REPLY" -le ${#SERVERS[@]} ]; then
SERVER="$SERVER_ITEM"
success "Selected server ${SERVER}"
break
fi
done
fi
2020-10-30 14:25:48 +00:00
SERVER="$ABRA_DIR/servers/$SERVER"
if [ ! -d "$SERVER" ]; then
error "Server '$SERVER' not found"
fi
APP_DIR="$ABRA_DIR/apps/$APP"
if [ -z "$DOMAIN" ]; then
read -rp "Domain name: " DOMAIN
fi
ENV_FILE="$SERVER/$DOMAIN.env"
if [ -f "$ENV_FILE" ]; then
error "$ENV_FILE already exists"
# FIXME 3wc: offer to user $STACK_$DOMAIN.env name instead
fi
cp "$APP_DIR/.envrc.sample" "$ENV_FILE"
sed -i "s/$APP\.example\.com/$DOMAIN/g" "$ENV_FILE"
2020-10-28 08:25:56 +00:00
sed -i "s/example\.com/$DOMAIN/g" "$ENV_FILE"
2020-10-27 22:29:40 +00:00
abra__domain_="$DOMAIN"
get_app_secrets
2020-11-05 14:56:31 +00:00
if [ "${#PASSWORDS[@]}" -gt 0 ] || [ "${#KEYS[@]}" -gt 0 ] && [ "$abra___auto" == "true" ]; then
sub_app_secret_auto
2020-10-27 22:29:40 +00:00
fi
echo "$(tput setaf 4)Your new '$APP' is ready for action:$(tput sgr0)"
echo " $(tput setaf 3)Customise the configuration:"
2020-10-28 08:25:56 +00:00
echo " abra app $DOMAIN config$(tput sgr0)"
echo " $(tput setaf 2)Deploy it:"
2020-10-28 08:25:56 +00:00
echo " abra app $DOMAIN deploy$(tput sgr0)"
}
2020-10-27 19:38:20 +00:00
###### .. app <domain> deploy
sub_app_deploy (){
load_instance
load_instance_env
2020-11-01 16:08:44 +00:00
require_app_clone "$APP"
echo "About to deploy:"
echo " Server: $(tput setaf 4)${SERVER}$(tput sgr0)"
if [ "${COMPOSE_FILE/:/}" == "${COMPOSE_FILE}" ]; then
echo " Compose: $(tput setaf 3)${APP_DIR}/${COMPOSE_FILE}$(tput sgr0)"
else
echo " Compose: $(tput setaf 3)${APP_DIR}/"
IFS=':' read -ra COMPOSE_FILES <<< "$COMPOSE_FILE"
for COMPOSE in "${COMPOSE_FILES[@]}"; do
echo " - ${COMPOSE}"
done
tput sgr0
fi
if [ -n "$DOMAIN" ]; then
echo " Domain: $(tput setaf 2)${DOMAIN}$(tput sgr0)"
fi
echo " Stack: $(tput setaf 1)${STACK_NAME}$(tput sgr0)"
2020-10-30 18:57:13 +00:00
prompt_confirm
2020-11-01 16:08:44 +00:00
APP=$(basename "$APP_DIR")
require_app_clone "$APP"
(
cd "$APP_DIR" || error "\$APP_DIR '$APP_DIR' not found"
# shellcheck disable=SC2086
2020-10-31 15:51:56 +00:00
if docker stack deploy -c ${COMPOSE_FILE//:/ -c } "$STACK_NAME"; then
if [ -n "$DOMAIN" ]; then
success "Yay! App should be available at https://${DOMAIN}"
else
success "Yay! That worked. No \$DOMAIN defined, check logs."
fi
else
error "Oh no! Something went wrong 😕 Check errors above"
fi
)
2020-09-07 21:29:29 +00:00
}
2020-10-27 23:40:35 +00:00
###### .. app <domain> undeploy
sub_app_undeploy (){
load_instance
load_instance_env
2020-10-31 15:51:56 +00:00
warning "About to un-deploy $STACK_NAME from $SERVER"
2020-10-30 18:57:13 +00:00
prompt_confirm
2020-10-27 23:40:35 +00:00
docker stack rm "$STACK_NAME"
}
2020-10-28 08:25:56 +00:00
###### .. app <domain> config
sub_app_config (){
load_instance
$EDITOR "$ENV_FILE"
}
###### .. app check
sub_app_check (){
load_instance
load_instance_env
APP_ENV=$(grep -v '^#' "$ENV_FILE" | sed 's/^.* \([^=]\+\)=.*/\1/' | sort)
STACK_ENV=$(grep -v '^#' "$APP_DIR/.envrc.sample" | sed 's/^.* \([^=]\+\)=.*/\1/' | sort)
# Only show "1", items in STACK_ENV which aren't in APP_ENV
MISSING_VARS=$(comm -23 <(echo "$STACK_ENV") <(echo "$APP_ENV"))
if [ -z "$MISSING_VARS" ]; then
success "Yay! All the necessary basic variables are defined"
exit 0
fi
error "Found missing variables: $MISSING_VARS"
}
###### .. app ps
sub_app_ps (){
load_instance
load_instance_env
docker stack ps "$STACK_NAME"
}
2020-10-27 23:40:35 +00:00
###### .. app <domain> delete
sub_app_rm (){
sub_app_delete
}
sub_app_delete (){
load_instance
load_instance_env
2020-10-27 23:52:27 +00:00
if [ "$abra___force" != "true" ]; then
warning "About to delete $ENV_FILE"
2020-10-30 18:57:13 +00:00
prompt_confirm
2020-10-27 23:52:27 +00:00
fi
2020-10-27 23:40:35 +00:00
rm "$ENV_FILE"
}
2020-10-27 19:38:20 +00:00
###### .. app <domain> secret insert
sub_app_secret_insert() {
load_instance
load_instance_env
2020-10-27 19:38:20 +00:00
SECRET="$abra__secret_"
VERSION="$abra__version_"
PW="$abra__data_"
2020-10-29 23:39:24 +00:00
STORE_WITH_PASS="$abra___pass"
2020-10-27 19:38:20 +00:00
if [ -z "$SECRET" ] || [ -z "$VERSION" ] || [ -z "$PW" ]; then
error "Required arguments missing"
fi
2020-11-17 22:40:26 +00:00
# shellcheck disable=SC2059
printf "$PW" | docker secret create "${STACK_NAME}_${SECRET}_${VERSION}" - > /dev/null
if [ "$STORE_WITH_PASS" == "true" ] && type pass > /dev/null 2>&1; then
2020-10-27 19:38:20 +00:00
echo "$PW" | pass insert "hosts/$DOCKER_CONTEXT/${STACK_NAME}/${SECRET}" -m > /dev/null
success "pass: hosts/$DOCKER_CONTEXT/${STACK_NAME}/${SECRET}"
fi
}
###### .. app <domain> secret delete
sub_app_secret_delete(){
sub_app_secret_rm
}
sub_app_secret_rm(){
load_instance
load_instance_env
# if --all is provided then $abra__secret_ will be blank and this will work
# auto-magically
NAMES=$(docker secret ls --filter "name=${STACK_NAME}_${abra__secret_}" --format "{{.Name}}")
2020-10-30 01:09:59 +00:00
if [ -z "$NAMES" ]; then
error "Could not find any secrets under ${STACK_NAME}_${abra__secret_}"
fi
if [ "$abra___force" != "true" ]; then
2020-10-30 18:57:13 +00:00
warning "About to delete $(echo "$NAMES" | paste -d "")"
prompt_confirm
2020-10-30 01:09:59 +00:00
fi
for NAME in ${NAMES}; do
2020-10-30 01:09:59 +00:00
docker secret rm "$NAME" > /dev/null
# as above, no need to test for --all, cos if abra__secret_ is blank it'll
# Just Work anyway
if [ "$abra___pass" == "true" ] && type pass > /dev/null 2>&1; then
pass rm -r "hosts/$DOCKER_CONTEXT/${STACK_NAME}/${abra__secret_}" > /dev/null \
&& success "pass rm'd: hosts/$DOCKER_CONTEXT/${STACK_NAME}/${abra__secret_}"
2020-10-30 01:09:59 +00:00
fi
done
}
2020-10-27 19:38:20 +00:00
###### .. app <domain> secret generate
sub_app_secret_generate(){
load_instance
load_instance_env
SECRET="$abra__secret_"
VERSION="$abra__version_"
2020-11-05 14:56:31 +00:00
LENGTH="$abra__length_"
2020-10-27 19:38:20 +00:00
2020-11-05 14:56:31 +00:00
if [[ "$SECRET" == *"password"* ]]; then
PWGEN="${abra__cmd_:-pwqgen}"
else
PWGEN=${abra__cmd_:-pwgen -s "$LENGTH" 1}
2020-11-05 14:56:31 +00:00
fi
2020-10-27 19:38:20 +00:00
if [ -z "$SECRET" ] || [ -z "$VERSION" ]; then
error "Required arguments missing"
fi
PW=$($PWGEN|tr -d "\n")
2020-10-27 19:38:20 +00:00
success "Password: $PW"
# TODO 3wc: this is a little janky, might be better to make a
2020-10-27 19:38:20 +00:00
# util_secret_insert function which this and sub_secret_insert can call
abra__data_="$PW"
sub_app_secret_insert
}
2020-10-27 22:29:40 +00:00
sub_app_secret_auto(){
load_instance
load_instance_env
get_app_secrets
2020-11-05 14:56:31 +00:00
for PASSWORD in "${PASSWORDS[@]}"; do
parse_secret "$PASSWORD"
done
for KEY in "${KEYS[@]}"; do
parse_secret "$KEY"
2020-10-27 22:29:40 +00:00
done
}
2020-10-27 19:38:20 +00:00
###### .. app <domain> run <args>...
sub_app_run(){
load_instance
2020-10-28 00:48:04 +00:00
load_instance_env
2020-10-27 19:38:20 +00:00
if [ -n "$abra___user" ]; then
RUN_USER="-u $abra___user"
fi
2020-12-26 15:22:56 +00:00
if [ "$abra___no_tty" = "true" ]; then
ARGS="-i"
else
ARGS="-it"
fi
2020-10-27 19:38:20 +00:00
CONTAINER=$(docker container ls --format "table {{.ID}},{{.Names}}" \
2020-10-28 08:25:56 +00:00
| grep "${STACK_NAME}_${abra__service_}" | head -n1 | cut -d',' -f1)
2020-10-27 19:38:20 +00:00
if [ -z "$CONTAINER" ]; then
2020-10-28 00:48:04 +00:00
error "Can't find a container for ${STACK_NAME}_${abra__service_}"
2020-10-27 19:38:20 +00:00
exit
fi
# 3wc: we want the "splitting" that shellcheck warns us about, so that -u and
# $RUN_USER aren't treated as a single argument:
2020-10-27 19:38:20 +00:00
# shellcheck disable=SC2086
2020-12-26 15:22:56 +00:00
docker exec $RUN_USER $ARGS "$CONTAINER" "$@"
2020-10-27 19:38:20 +00:00
return
}
###### .. app <domain> multilogs
sub_app_multilogs() {
# Inspired by https://github.com/moby/moby/issues/31458#issuecomment-475411564
require_multitail
load_instance
load_instance_env
# Get a list of the service names
SERVICES=$(docker stack services --format "{{.Name}}" "${STACK_NAME}")
# Sort the service names
SERVICES=$(echo "${SERVICES}" | sort)
# Create the command to run
COMMAND='multitail --mergeall'
for SERVICE in ${SERVICES}; do
COMMAND="${COMMAND} -L 'docker service logs --tail 20 -f ${SERVICE}'"
done
# Run the command
bash -c "${COMMAND}"
2020-09-24 22:36:23 +00:00
}
2020-10-27 19:38:20 +00:00
###### .. app <domain> logs <service> <args>...
sub_app_logs (){
load_instance
load_instance_env
2020-10-26 14:54:55 +00:00
SERVICE="${abra__service_}"
if [ -z "$SERVICE" ]; then
warning "No \$SERVICE provided, running multilogs"
2020-10-27 19:38:20 +00:00
sub_app_multilogs
return
fi
shift
if [ $# -eq 0 ]; then
LOGS_ARGS="\
--follow \
--tail 20 \
--no-trunc \
--details \
--timestamps"
else
# shellcheck disable=SC2124
LOGS_ARGS=$@
fi
# shellcheck disable=SC2086
docker service logs "${STACK_NAME}_${SERVICE}" $LOGS_ARGS
2020-09-08 07:10:37 +00:00
}
2020-10-27 19:38:20 +00:00
###### .. app <domain> cp <src> <dst>
sub_app_cp() {
2020-10-28 00:48:04 +00:00
load_instance
load_instance_env
2020-09-23 09:53:34 +00:00
2020-10-26 14:54:55 +00:00
SOURCE="${abra__src_}"
DEST="${abra__dst_}"
2020-10-26 16:19:32 +00:00
# Get the service name from either SOURCE or DEST
SERVICE=$(echo "$SOURCE" | grep -o '^[^:]\+:' || echo "$DEST" | grep -o '^[^:]\+:')
SERVICE=$(echo "$SERVICE" | tr -d ':')
if [ -z "$SERVICE" ]; then
echo "Usage: $PROGRAM_NAME cp SERVICE:SRC_PATH DEST_PATH"
echo " $PROGRAM_NAME cp SRC_PATH SERVICE:DEST_PATH"
echo ""
error "Can't find SERVICE in either SRC or DEST"
fi
CONTAINER=$(docker container ls --format "table {{.ID}},{{.Names}}" \
| grep "${STACK_NAME}_${SERVICE}" | cut -d',' -f1)
if [ -z "$CONTAINER" ]; then
error "Can't find a container for ${STACK_NAME}_${SERVICE}"
exit
fi
# Replace $SERVICE with $CONTAINER in the original args
CP_ARGS=$(echo "$SOURCE $DEST" | sed "s/$SERVICE:/$CONTAINER:/")
# FIXME 3wc: this might cause problems for filenames with spaces..
# shellcheck disable=SC2086
docker cp ${CP_ARGS}
}
2020-10-27 19:38:20 +00:00
#######################################
# abra server ..
#######################################
2020-10-28 00:48:04 +00:00
###### .. server ls
sub_server_ls() {
sub_server_list
}
sub_server_list() {
get_servers
printf "%s servers:\n\n" "${#SERVERS[@]}"
for SERVER in "${SERVERS[@]}"; do
echo " ${SERVER##*/}"
done
}
2020-10-27 19:38:20 +00:00
###### .. server init <host>
2020-10-23 03:02:39 +00:00
sub_server_init() {
2020-10-26 14:54:55 +00:00
export DOCKER_CONTEXT="${abra__host_}"
2020-10-26 09:58:15 +00:00
2020-10-27 22:29:40 +00:00
load_context
docker swarm init || true
docker network create --driver=overlay proxy --scope swarm || true
}
2020-10-28 00:48:04 +00:00
###### .. server <add> <host> [<username>] [<password>]
2020-10-23 03:02:39 +00:00
sub_server_add() {
2020-10-27 23:40:35 +00:00
require_abra_dir
HOST="$abra__host_"
USERNAME="$abra__user_"
PORT="$abra__port_"
if [ -n "$PORT" ]; then
PORT=":$PORT"
fi
if [ -n "$USERNAME" ]; then
USERNAME="$USERNAME@"
fi
docker context create "$HOST" \
--docker "host=ssh://$USERNAME$HOST$PORT" \
|| true
2020-10-27 23:40:35 +00:00
2020-10-28 16:32:38 +00:00
mkdir -p "$ABRA_DIR/servers/$HOST"
}
2020-10-28 00:48:04 +00:00
###### .. server <host> delete
2020-10-23 03:02:39 +00:00
sub_server_rm() {
2020-10-28 00:48:04 +00:00
sub_server_delete
}
sub_server_delete() {
docker context rm "$abra__host_"
2020-10-23 03:02:39 +00:00
}
2020-10-28 00:48:04 +00:00
###### .. server <host> use
2020-10-23 03:02:39 +00:00
sub_server_use() {
docker context use "$abra__host_"
}
###### .. server <host> apps
sub_server_apps() {
abra___server="$abra__host_"
sub_app_list
}
2020-10-27 19:38:20 +00:00
#######################################
# Misc commands
#######################################
2020-10-28 00:48:04 +00:00
###### .. upgrade
2020-09-23 09:53:34 +00:00
sub_upgrade() {
2020-10-26 17:31:03 +00:00
curl https://install.abra.autonomic.zone | bash
2020-09-23 09:53:34 +00:00
}
2020-12-27 10:05:49 +00:00
###### .. stack <args>...
sub_stack() {
# shellcheck disable=SC2068
docker stack $@
}
2020-12-27 10:05:49 +00:00
###### .. volume <args>...
sub_volume() {
# shellcheck disable=SC2068
docker volume $@
}
2020-12-27 10:05:49 +00:00
###### .. network <args>...
sub_network() {
# shellcheck disable=SC2068
docker network $@
}
2020-10-27 19:38:20 +00:00
#######################################
# Main
#######################################
2020-10-26 08:46:14 +00:00
abra() {
2020-10-26 14:54:55 +00:00
# TODO (3wc): we either need to do this, or add 'shellcheck disable' all over
# the place to handle the dynamically-defined vars
2020-10-27 19:38:20 +00:00
declare abra___stack abra___env abra__command_ abra__args_ \
abra__secret_ abra__version_ abra__data_ abra___user abra__host_ \
abra__app_ abra__port_ abra__user_ abra__service_ abra__src_ abra__dst_ \
2020-11-05 15:00:50 +00:00
abra__domain_ abra___server abra___domain abra___force abra___pass \
2020-12-26 15:22:56 +00:00
abra___auto abra___status abra___no_tty
2020-10-26 11:33:06 +00:00
2020-10-29 17:40:19 +00:00
if ! type tput > /dev/null 2>&1; then
tput() {
echo -n
}
fi
2020-10-26 11:33:06 +00:00
DOCOPT_PREFIX=abra_
2020-10-26 08:46:14 +00:00
eval "$(docopt "$@")"
2020-10-26 11:33:06 +00:00
2020-10-28 00:48:04 +00:00
# --stack <stack>
STACK_NAME=$abra___stack
2020-10-28 00:48:04 +00:00
# --env <env>
if [ -n "$abra___env" ]; then
# shellcheck disable=SC1090
source "$abra___env" || error "Unable to load env from '$abra___env'"
fi
load_custom_commands
# Search for sub_* functions, and check if any of them matches enabled
# arguments (i.e. is a command and is specified)
for SUBCOMMAND in $(declare -Ff | grep 'sub_' | cut -d' ' -f3 | sort -r); do
IFS='_' read -r -a PARTS <<< "$SUBCOMMAND"
for PART in "${PARTS[@]:1}"; do
2020-10-30 16:17:06 +00:00
# TODO 3wc: probably a better way to check if a variable is defined..
VAR=$(eval "echo \$abra_$PART")
if [ ! "$VAR" == "true" ]; then
continue 2
fi
done
abra__command_=$(IFS="_"; echo "${PARTS[*]:1}")
2020-10-30 16:17:06 +00:00
break
done
2020-10-28 00:48:04 +00:00
# Use abra__command_ in case `command` is provided (i.e. `volume` or `stack`)
CMD="sub_${abra__command_}"
if type "$CMD" > /dev/null 2>&1; then
# shellcheck disable=SC2086
"$CMD" ${abra__args_[*]}
else
"$CMD not found"
docopt_exit
fi
2020-10-26 08:46:14 +00:00
}
abra "$@"